//  /  / FT245
//  CLK    J   EPM3064
module MYLATCH  (N_RD, WR, Jready , Jfull, N_RXF, N_TXE, ENABLE, CLK);
  input CLK;   // .   24    6 .
input ENABLE; 
  input N_TXE; //     FT245 ,  0
  input N_RXF; //     FT245 ,  0

  input Jfull;  //   JTAG     
  input Jready; //   JTAG   

  output WR;    //     FT245   
  output N_RD;  //     FT245,  0

  reg Jwrite, Jread ; //, WR;

//        
// 
  wire RXF, TXE;
  reg RD;
  reg tmp;
// 
assign RXF  = ~N_RXF;
assign TXE  = ~N_TXE;
// 
assign N_RD = ~RD;

/*
initial
begin
 Jwrite=0;
 Jread=0;
 WR=0;
 RD=0;
end
*/

/*
always @(posedge RXF)
begin
 RD=1; 
end

always @(negedge RXF)
begin
 RD=0;
end
*/
//   RD=0;

assign WR=0;

always @(posedge CLK)
begin 
if (ENABLE)
begin
 if ((RXF) && (Jready)) //    JTAG  
  begin
   if (tmp) RD=1;
    else tmp=1;
  end 
 else 
  begin
   RD=0;
   tmp=0;
  end
end //if (ENABLE)
end  //always @(posedge CLK)

/*
always @(negedge RXF)
begin
  Jwrite=0;
  RD=0;
end
*/
endmodule
