//   / /
//       
//     ,   
//       
//  8    
// C      .
module shiftout (dout, so, rdy, T_CLK, din, si, load, reset, clk);
 output [7:0] dout; //  
 output so;         //   (TDI)
 output rdy;        //    / 
 output T_CLK;      //     so
 input [7:0] din;   //  
 input si;          //    (TD0)
 input load;        //  
 input reset;       // 
 input clk;         //  

 reg rdy;              //     

 reg [3:0] bitcount;   //  
 reg [7:0] shifter;    //  
 reg T_CLK;            //     

assign so = dout[0];
assign dout =shifter;

always @(posedge clk)
begin
 if (reset)   //    
  begin
   bitcount=0;
   T_CLK<=0;
   rdy<=1;
  end
 else if (~rdy) //   . 
  begin
   if (T_CLK) //      
    begin
     shifter<= shifter>>1;
     shifter[7]<=si;
     T_CLK=0;
    end  
   else
    begin
     if (bitcount==0) rdy=1;
     else
      begin
       bitcount=bitcount-1; //      
       T_CLK=1;
      end
    end
  end 

 else if ((rdy) && (load)) //  ,    
  begin
   shifter[7:0]<=din[7:0]; //      (so)
   bitcount=4'b1000;	   //  8 
   T_CLK<=0;               //  
   rdy<=0;
  end
end
endmodule
